lparts = ['minimal_sent',
          'substantive_phrase',
          'predicate_phrase',
          'adverbials',
          'very_more',
          'meta']

subparts = {
    'minimal_sent' : ['aff_minimal_sent', 'neg_minimal_sent'],

    'substantive_phrase' : [
        'att_relation1', 'att_relation2', 'det_relation', 'q_relation', 'class_relation',
        'part_relation', 'same_relation', 'other_relation',
        'selection_relation', 'possessive_relation'],

    'predicate_phrase' : [
        'time_dep', 'transitive', 'do_happen_move', 'live_die',
        'existence', 'location_preds', 'mental_preds', 'exp_preds',
        'evaluation_preds'],
    
    'do_happen_move' : [
        'do', 'happen', 'move'],

    'live_die' : ['live','die'],

    'location_preds' : ['be_in_place', 'be_here',
                        'be_above', 'be_below',
                        'be_far', 'be_near',
                        'be_inside', 'be_on_this_side', 'be_on_the_other_side'],
    
    'mental_preds' : ['know', 'think', 'say','want'],

    'exp_preds' : ['see', 'hear', 'feel'],

    'evaluation_preds' : ['be_good','be_like'],

    'adverbials' : ['time_adj', 'repet_adj', 'location_adj', 'manner_adj'],

    'time_adj' : ['time_loc_scalar' , 'time_loc_scalar_with_dist',
                  'time_dur'],
    
    'manner_adj' : ['adverbial_like_this'],

    'very_more' : ['intensifier', 'more'],

    'meta' : ['meta_1', 'meta_2'],

    'meta_1' : ['not', 'can', 'maybe'],
    'meta_2' : ['because', 'if', 'as']
    }

lex_entries = {
    'substantive_phrase' : ['ME','YOU','PERSON','THING'],
    'intensifier' : ['VERY'],
    'more' : ['MORE'],
    'meta1' : ['MAYBE','NOT','CAN'],
    'meta2' : ['IF','BECAUSE']
    }
    


