import sys

op_counter = 0
verbose = False
test_mode = False


def print_stack(stack):
    for item in stack:
        print item[0][3], '['+item[2], ' ...]; ',    


def notify_scan(res,stack):
    if res:
        t = res[0]
        if t[0] == 0 and t[1] == 0: pass
        else: print '('+str(t[0])+','+str(t[1])+')'
        print ' -- pf: ',t[2],'\n -- lf: ',t[3],'\n -- f: ',repr(res[1:])
        print ' -- stack : ',
        print_stack(stack)
    else: print 'Not found'



def print_member(first,pre):
    t = first[0]
    if t[0] == 0 and t[1] == 0: pass
    else: print pre,'('+str(t[0])+','+str(t[1])+')',
    print pre,' -- pf: ',repr(t[2])
    print ' '*len(pre),' -- f: ',repr(first[1:])


def notify_merge(chain):
    if chain == False:
        print False
        return
    ch = chain[:]
    t = ch[0]
    print ' -- lf: ',t[3]
    ch_member = 0
    cont = True
    while '#' in ch:
        ch_member += 1
        pre = '#' + str(ch_member)
        first, ch = ch[:ch.index('#')], ch[ch.index('#')+1:]
        print_member(first,pre)
        print '-'*10
    ch_member += 1
    pre = '#' + str(ch_member)
    print_member(ch,pre)

    


    
def notify(op,res,stack):
    global op_counter, verbose
    op_counter += 1
    print '---------------------------'
    print op_counter, op
    if op == 'SCAN': notify_scan(res,stack)
    elif op == 'MERGE': notify_merge(res)
    elif op == 'MOVE': notify_merge(res)
    elif op == 'ADD': notify_merge(res)
    print

    
def notify_init(agenda):
    print ' ----------------------------'
    print 'AGENDA INITIALISATION'
    for item in agenda:
        print item,'\n-----'

def notify_continuation(item,i,s,stack):
    print '----------------------------'
    global op_counter
    op_counter += 1
    print op_counter,'ADD CONTINUATION'
    print 'Sent  : '+ repr([item + '_' + str(i+1)] + s[:])
    print 'Stack :' + repr(stack)



def notify_backtrack(item,i,s,stack):
    print '----------------------------'
    global op_counter
    op_counter += 1
    print op_counter,'BACKTRACK'
    print 'Sent  : '+ repr([item + '_' + str(i+1)] + s[:])
    print 'Stack :' + repr(stack)

def notify_change(s):
    print ' ==> ',s,'\n ----'

def notify_message(s):
    print s


def alert(s):
    print >> sys.stderr, ' ** ' + s

