import re
var_number = 0

var_residue = re.compile(r'\.\d+\$')

def pos(s,l,start = 0):
    i = -1
    try:
        i = l.index(s,start)
    except ValueError:
        return  -1
    else:
        return i


def add_list(i1,i2):
    if len(i2) > 2:
        if i2[0] == ':' : i2.pop(0)
        if i2[0] == '#':
            i1.extend(i2)


def is_last_feature(item):
    return len(item) < 3 or (len(item) > 3 and item[2] == '#')
    


def index_vars(l):
    global var_number
    d = dict()
    for item in l:
        if '$' in item:
            v = extract_var(item)
            if not (d.has_key(v)):
                var_number += 1
                d[v] = '$'+ v[1:-1] + '.' + str(var_number) + '$'
    newlist = []
    for item in l:
        for key in d:
            if key in item:
                item = item.replace(key,d[key])
        newlist.append(item)
    return newlist


def inst_val(i_list,v1,v2):
    newlist = []
    if v2[0] == '$' and v1[0] <> '$':
        v1, v2 = v2, v1
    for item in i_list:
        if type(item) == tuple:
            newlist.append(tuple([item[0], item[1],
                                  item[2].replace(v1,v2),
                                  item[3]]))
        else:
            newlist.append(item.replace(v1,v2))
    return newlist


def inst_default(string,d):
    global var_residue
    for key in d:
        string = string.replace('$'+key+'.',d[key]+'.')
    return var_residue.sub('',string)
        

def inst_variables(ch1,ch2,f1,f2):
    if (len(f1) > 1) and (len(f2) > 1):
        v1, v2 =  f1[1], f2[1]
        if v1[0] <> '$' and v2[0] <> '$':
            if v1 <> v2: return None, None
            else: return ch1, ch2
        else:
            return inst_val(ch1,v1,v2), inst_val(ch2,v1,v2)
    else:
        return ch1, ch2


def extract_var(s):
    i = s.index('$')
    i2 = s.index('$',i+1) + 1
    return s[i:i2]


