# -*- coding: cp1252 -*-
import variables


##def contiguous(from1,to1,from2,to2):
##    if (from1,to1) == (-1,-1) and (from2,to2) != (-1,-1):
##        return True
##    elif (from1,to1) != (-1,-1) and (from2,to2) == (-1,-1):
##        return True
##    else:
####        if invert:
####            from1, to1, from2, to2 = from2, to2, from1, to1
##        return (to1 == from2 and to1 != -1 and from1 < to2)
##
##
##def add_span(from1,to1,from2,to2):
####    if invert:
####        from1, to1, from2, to2 = from2, to2, from1, to1
##    if (from1,to1) == (-1,-1):
##        return from2,to2
##    elif (from2,to2) == (-1,-1):
##        return from1,to1
##    else:
##        return from1,to2

    
def get_top_feature(item):
    if len(item) <= 2: return None 
    else: return item[2]


    
def not_null_chain(chain):
    for item in chain:
        if item <> -1:
            return item
    else:
        return -1

def eq(pos1,pos2):
    return (pos1 == pos2 and pos1 <> -1) or (pos1 == -1) or (pos2 == -1)
    

def s_merge2(i1,i2,cat):
    old_i1, old_i2 = i1[:], i2[:]
    i1[1] = ':'
    i2[1] = ':'
    i = variables.pos('#',i1,0)
    if i <> -1:
        i1_rest_chain = i1[i:]
        i1 = i1[:i]
    else: i1_rest_chain = []
    i = variables.pos('#',i1,0)
    if i <> -1:
        i2_rest_chain = i2[i:]
        i2 = i2[:i]
    else: i2_rest_chain = []
    from_v, from_w, from_x = i2[0][0][0], i2[0][0][1], i2[0][0][2]
    to_v, to_w, to_x = i2[0][1][0], i2[0][1][1], i2[0][1][2]

    from_v = not_null_chain([from_v,from_w,from_x])
    to_x = not_null_chain([to_x,to_w,to_v])
    
    i2[0] = (from_v,to_x,''.join(i2[0].split(',')),'')
    i1[0] = (i1[0][0], i1[0][1], i1[0][2], i2[0][3]+' ' +i1[0][3])
    i1.append('#')
    i1.extend(i2)
    i1.extend(i1_rest_chain)
    i1.extend(i2_rest_chain)
    return i1


def s_merge1(i1,i2,cat):
    s,t,u = tuple(i1[0][2].split(','))
    v,w,x = tuple(i2[0][2].split(','))
    new_string = v+w+x+s+','+t+','+u
    i1[1] = ':'

    from_s, from_t, from_u = i1[0][0][0], i1[0][0][1], i1[0][0][2]
    to_s, to_t, to_u = i1[0][1][0], i1[0][1][1], i1[0][1][2]

    from_v, from_w, from_x = i2[0][0][0], i2[0][0][1], i2[0][0][2]
    to_v, to_w, to_x = i2[0][1][0], i2[0][1][1], i2[0][1][2]

    from_v  = not_null_chain([from_v,from_w,from_x,from_s])
    to_s = not_null_chain([to_s,to_x,to_w,to_v])

    i1[0] = tuple([[from_v,from_t,from_u]
                   [to_s,to_t,to_u],
                   new_string,
                   i2[0][3] + ' ' + i1[0][3]])
    variables.add_list(i1,i2[1:])
    return i1



def c_merge2(i1,i2,cat):
    s,t,u = tuple(i1[0][2].split(','))
    v,w,x = tuple(i2[0][2].split(','))
    new_string = s+','+w+t+','+u+v+x
    i1[1] = ':'

    from_s, from_t, from_u = i1[0][0][0], i1[0][0][1], i1[0][0][2]
    to_s, to_t, to_u = i1[0][1][0], i1[0][1][1], i1[0][1][2]

    from_v, from_w, from_x = i2[0][0][0], i2[0][0][1], i2[0][0][2]
    to_v, to_w, to_x = i2[0][1][0], i2[0][1][1], i2[0][1][2]

    from_w = not_null_chain([from_w,from_t])
    to_t = not_null_chain([to_t,to_w])

    from_u = not_null_chain([from_u, from_v, from_x])
    to_x = not_null_chain([to_x, to_v, to_u])
    
    i1[0] = tuple([[from_s,from_w,from_u]
                   [to_s,to_t,to_x],
                   new_string,
                   i2[0][3] + ' ' + i1[0][3]])
    variables.add_list(i1,i2[1:])
    return i1


def c_merge1(i1,i2,cat):
    s,t,u = tuple(i1[0][2].split(','))
    v,w,x = tuple(i2[0][2].split(','))
    new_string = s+u+v+','+w+t+','+x
    i1[1] = ':'

    from_s, from_t, from_u = i1[0][0][0], i1[0][0][1], i1[0][0][2]
    to_s, to_t, to_u = i1[0][1][0], i1[0][1][1], i1[0][1][2]
    
    from_v, from_w, from_x = i2[0][0][0], i2[0][0][1], i2[0][0][2]
    to_v, to_w, to_x = i2[0][1][0], i2[0][1][1], i2[0][1][2]

    from_s = not_null_chain([from_s, from_u, from_v])
    to_v = not_null_chain([to_v,to_u,to_s])

    from_w = not_null_chain([from_w,from_t])
    to_t = not_null_chain([to_t,to_w])
    
    i1[0] = tuple([[from_s,from_w,from_x]
                   [to_v,to_t,to_x],
                   new_string,
                   i2[0][3] + ' ' + i1[0][3]])
    variables.add_list(i1,i2[1:])
    return i1



def can_merge(i1,i2):
    if i1[0] == '=':
        t = 'c'
        i1 = i1[1:]
    elif i1[-1] == '=':
        t = 's'
        i1 = i1[:-1]
    else:
        return False
    
    if i1 == i2:
        return t
##        elif '|' in i1[0]:
##            for alt in i1[0].split('|'):
##                new_i1 = [alt.strip()]
##                new_i1.extend(i1[1:])
##                if can_merge(new_i1,i2):
##                    return True
##            else: #else del for
##                return False
    else:
        f1, f2 = i1.split(':'), i2.split(':')
        if len(f1) == 1: f1.append('-1')
        if len(f2) == 1: f2.append('-1')
        try: n1, n2 = int(f1[1]), int(f2[1])
        except ValueError: return False
        else: return f1[0] == f2[0] and (
            n1 >= n2 or n1 == -1 or n2 == -1)



def trymerge(item,top):
    if len(item) > 2 and len(top) > 2:
        t = can_merge(item[2],top[2])
        if t:
            cat = top.pop(2)
            item.pop(2)
            if len(item) > 2 and item[2] == '*':
                strong = True
                item.pop(2)
            else:
                strong = False
            if ( (not '#' in item)
    ##             and len(item) > 1 and item[1] == '::'
                 and variables.is_last_feature(top)):
                if t == 's': return s_merge1(item,top,cat,strong)
                elif t == 'c': return c_merge1(item,top,cat,strong)
            else:
                if t == 's': return s_merge2(item,top,cat,strong)
                else: return c_merge2(item,top,cat,strong)
        else:
            return False
    else:
        return False



def try_unmerge(item,top):
    if len(item) > 2 and len(top) > 2:
        t = can_merge(item[2],top[2])
        if t:
            item.pop(2)
            cat = top.pop(2)
            if len(item) > 2 and item[2] == '*':
                strong = True
                item.pop(2)
            else:
                strong = False
            from_s, from_t, from_u = item[0][0][0], item[0][0][1], item[0][0][2]
            to_s, to_t, to_u = item[0][1][0], item[0][1][1], item[0][1][2]
            
            from_v, from_w, from_x = top[0][0][0], top[0][0][1], top[0][0][2]
            to_v, to_w, to_x = top[0][1][0], top[0][1][1], top[0][1][2]

            if ( (not '#' in item)
##                 and len(item) > 1 and item[1] == '::'
                 and variables.is_last_feature(top) ):
                if (t == 's'
                    and (eq(to_v,from_w) and eq(to_w,from_x) and eq(to_x,from_s))):
                    return s_merge1(item,top,cat)
                elif (t == 'c'
                      and (eq(to_s,from_u) and eq(to_u,from_v) and eq(to_w,from_t)) ):
                    return c_merge1(item,top,cat,strong)
            elif (t == 's' and eq(to_v,from_w) and eq(to_w,from_x)):
                    return s_merge2(item,top,cat,strong)
            elif (t == 'c'
                  and eq(to_w,from_t) and eq(to_u,from_v) and eq(to_v,from_x)):
                return c_merge2(item,top,cat,strong)                
            else:return False
        else: return False
    else: return False



def move2(ch1,ch2,item):
    ch1.append('#')
    ch1.extend(ch2)
    return ch1


def move1(ch1,ch2,item):
    old_item = item[:]
##    if covert:
##        from3,to3 = add_span(ch1[0][0],ch1[0][1],ch2[0][0],ch2[0][1])    
##        ch1[0] = tuple([from3,to3,
##                        ch1[0][2]+' '+ ch2[0][2],
##                        ch1[0][3]])

    from_s, from_t, from_u = ch1[0][0][0], ch1[0][0][1], ch1[0][0][2]
    to_s, to_t, to_u = ch1[0][1][0], ch1[0][1][1], ch1[0][1][2]

    from_v, to_v = ch2[0][0], ch2[0][1]

    from_v = not_null_chain([from_v,from_s])
    to_s = not_null_chain([to_s,to_v])

    ch1[0] = tuple([[from_v,from_t,from_u],
                    [to_s, to_t, to_u],
                    ch2[0][2]+' '+ ch1[0][2],
                    ch1[0][3]])
    if '#' in ch2:
        ch1.extend(ch2[ch2.index('#'):])
    variables.add_list(ch1,ch2)




def inst_feature_dict(item):
    if len(item) > 0 and type(item) == list and type(item[-1]) == dict:
        d = item.pop()
        for key in d:
            for j in range(2,len(item)):
                item[j] = item[j].replace(key,d[key])
            


def prepare_move(item,i):
    ch1, ch2 = item[:i],item[i+1:]
    fv1, fv2 = get_top_feature(ch1), get_top_feature(ch2)
    if fv1 and fv2:
        f1, f2 = fv1.split(':'), fv2.split(':')
        if f1[0][1:] == f2[0][1:] and f1[0][0] == '+' and f2[0][0] == '-':
            ch1.pop(2)
            ch2.pop(2)
#            covert = len(ch1) > 2 and ch1[2] == '>'
#            if covert: ch1.pop(2)
            inst_feature_dict(ch1)
            inst_feature_dict(ch2)            
            ch1, ch2 = variables.inst_variables(ch1,ch2,f1,f2)
            return ch1, ch2
        else:
            return None


def trymove(item,unmove = False):
    i = variables.pos('#',item)
    while i <> -1:
        chains = prepare_move(item,i)
        if chains and chains <> (None,None):
            ch1, ch2 = chains
            if ch1 and ch2:
                if variables.is_last_feature(ch2):
                    if not unmove:
                        move1(ch1,ch2,item)
                        return ch1
                    else:
                        from_s, from_t, from_u = item[0][0][0], item[0][0][1], item[0][0][2]
                        to_s, to_t, to_u = item[0][1][0], item[0][1][1], item[0][1][2]

                        from_v, to_v = ch2[0][0], ch2[0][1]
                        
                        if (eq(to_v,from_s)):
                            move1(ch1,ch2,item)
                            return ch1
                        else:
                            i = variables.pos('#',item,i+1)
                else:
                    move2(ch1,ch2,item)
                    return ch1
            else: i = variables.pos('#',item,i+1)
        else:
            i = variables.pos('#',item,i+1)               
    return None

    




