import re

    
def twotape_sub(RegExp, String, NewString, Table):
    s = String[:]
    res = ''
    m = re.search(RegExp,s)
    while m:        
        s1 = NewString
        for i,item in enumerate(m.groups()):
            if Table.has_key(item):
               s1 = s1.replace("%" + str(i+1),Table[item],1)
               s1 = s1.replace("\\" + str(i+1),item,1)
               s1 = s1.replace("$" + str(i+1),item,1)
            elif item == None:
               s1 = s1.replace("%" + str(i+1),'',1)
               s1 = s1.replace("\\" + str(i+1),'',1)
               s1 = s1.replace("$" + str(i+1),'',1)
        res += s[0:m.start()] + s1
        s = s[m.end():]
        m = re.search(RegExp,s)
    res += s   
    return res


def test():    
    r = re.compile(r"(this|that) (person|thing) is (good|bad|big|small)")    
    s = "this person is good. \nthis thing is big. ciao\n"
    table = {'good' : 'buena', 'bad' : 'mala',
             'big' : 'grande', 'small' : 'pequenya',
             'this' : 'esta', 'that' : 'esa',
             'person' : 'persona', 'thing' : 'cosa'}
    print twotape_sub(r,s,"%1 %2 es %3",table)
    


#{}
